"use strict"
// базовый общий для всех
XHEBaseObject = require("../../xhe_base.js")

/////////////////////////////////////////// Plgn_PowerPoint ////////////////////////////////////////
class XHEPOWERPOINT extends XHEBaseObject
{
///////////////////////////////// SERVICE FUNCTIONS ////////////////////////////////////////////////
    // server initialization
    constructor(server, password = "") {
	    super(server, password, "Plgn_PowerPoint")
    }
/////////////////////////////////////////////////////////////////////////////////////////////////////

    // получить текст из всех слайдов
    read_document(document_path, password="unkown") {
        const params = ["document_path", document_path, "password", password]
        return this.call_get("read_document", params)
    }

    // получить текст из слайда
    read_slide(document_path, number, password="unkown") {
        const params = ["document_path", document_path, "number", number, "password", password]
        return this.call_get("read_slide", params)
    }

    // удалить слайд
    delete_slide(document_path, number, password="unkown") {
        const params = ["document_path", document_path, "number", number, "password", password]
        return this.call_get("delete_slide", params)
    }

    // экспорт PPT в PDF
    export_ppt_to_pdf(document_path, pdf_path, password="unkown") {
        const params = ["document_path", document_path, "pdf_path", pdf_path, "password", password]
        return this.call_get("export_ppt_to_pdf", params)
    }

    // получить количество слайдов в документе
    get_slide_count(document_path, password="unkown") {
        const params = ["document_path", document_path, "password", password]
        return this.call_get("get_slide_count", params)
    }

    // вставить слайд в PPT
    insert_new_slide(document_path, number, layout="Microsoft.Office.Interop.PowerPoint.PpSlideLayout.ppLayoutBlank", password="unkown") {
        const params = ["document_path", document_path, "number", number, "layout", layout, "password", password]
        return this.call_get("insert_new_slide", params)
    }

    // добавить слайд к PPT
    append_slide(document_path, layout="PpSlideLayout.ppLayoutBlank", password="unkown") {
        const params = ["document_path", document_path, "layout", layout, "password", password]
        return this.call_get("append_slide", params)
    }
}
module.exports = XHEPOWERPOINT
